// MainWindow.cpp
//

//#ifdef _DEBUG
//#define new DEBUG_NEW
//#undef THIS_FILE
//static char THIS_FILE[] = __FILE__;
//#endif

#include "stdafx.h"
#include "resource.h"
#include "MainWindow.h"
#include "TheApp.h"

/////////////////////////////////////////////////////////////////////////////
// MainWindow

static int windowW=640;
static int windowH=480;	//Width and Height of the Window


CMainWindow::CMainWindow(LPCSTR ClassName)
{	 
	//Center the Window on the Screen
    int xoffset=(::GetSystemMetrics(SM_CXSCREEN) - windowW) / 2; 
	int yoffset=(::GetSystemMetrics(SM_CYSCREEN) - windowH) / 2;

	//Create the Window
	Create(ClassName,"Line Animation with MFC",
		WS_OVERLAPPED|WS_SYSMENU|WS_MINIMIZEBOX,
		CRect(xoffset,yoffset,xoffset+windowW,yoffset+windowH),NULL);	

	TheApp* tApp = (TheApp*)AfxGetApp();
    tApp->mw = this;

	CClientDC dc(this);

	//DC and BMP are prepared
	memDC.CreateCompatibleDC(&dc);
	memBMP.CreateCompatibleBitmap(&dc, windowW, windowH);
	memDC.SelectObject(&memBMP);

	//Create some different colored Pen's
	fuchsiaPen.CreatePen(PS_SOLID, 1, RGB(255,50,255));
	bluePen.CreatePen(PS_SOLID, 1, RGB(0,0,255));
	aquaPen.CreatePen(PS_SOLID, 2, RGB(200,200,255));
	redPen.CreatePen(PS_SOLID, 2, RGB(255,0,0));
	yellowPen.CreatePen(PS_SOLID, 2, RGB(255,255,0));

	m_dFPS = 0; 
	m_iFrame = 0;

	//our target frame rate
	m_dFrameRate = 60;	//30			

	m_dwTicksPerFrame = (int)(1000.0/(m_dFrameRate*1.1));	
	if(m_dwTicksPerFrame > 1000) m_dwTicksPerFrame = 1000;
	if(m_dwTicksPerFrame < 1) m_dwTicksPerFrame = 1;
}

CMainWindow::~CMainWindow()
{		
	fuchsiaPen.DeleteObject();
	bluePen.DeleteObject();
	aquaPen.DeleteObject();
	redPen.DeleteObject();
	yellowPen.DeleteObject();

	memDC.DeleteDC();	
	memBMP.DeleteObject();
}

BEGIN_MESSAGE_MAP(CMainWindow, CFrameWnd)
	//{{AFX_MSG_MAP(MainWindow)	
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen Nachrichten MainWindow 

void CMainWindow::TimerReset(int timerID)
{
	int i;

	_ASSERT(timerID == -1 || (timerID >=0 && timerID < 50));

	if(!timersinitialized) {
		timerID = -1;
		QueryPerformanceFrequency(&timerfreq);
		timefactor = 1000000.0 /  (double)(timerfreq.LowPart);
		timersinitialized = true;
	}

	if(timerID == -1) {
		for(i = 0; i < 50; i++) {
			QueryPerformanceCounter(&timercount[i]);
		}
	}
	else  QueryPerformanceCounter(&timercount[timerID]);

}

DWORD CMainWindow::TimerCheck(int timerID)
{
	LARGE_INTEGER *lpt1,t2;
//	_ASSERT(timerID >=0 && timerID < DVMAX_TIMERS);

	lpt1 = &timercount[timerID];
	QueryPerformanceCounter(&t2);

	if(lpt1->HighPart ==  t2.HighPart) 
		return 	(DWORD)((t2.LowPart -  lpt1->LowPart)*timefactor);
	else  return 	(DWORD)((0xffffffff- lpt1->LowPart +  t2.LowPart)*timefactor);
}

BOOL CMainWindow::CheckNextFrame()
{
 	static DWORD nexttick;								
	DWORD tick;
	DWORD count;				
	
	tick = GetTickCount();

	if(nexttick > tick + m_dwTicksPerFrame*2) 
		nexttick = tick + m_dwTicksPerFrame;
	if(tick < nexttick) return false;		
								
	if(!(m_iFrame % 30)) {
		count=TimerCheck(50-1);
		TimerReset(50-1);
		if(count <1) count = 1;
		m_dFPS = 1000000.0 / count * 30.0;
	}
	
	nexttick = GetTickCount() + m_dwTicksPerFrame;
	return true;
}


void CMainWindow::OnPaint() 
{
	CPaintDC dc(this);
	
	DrawStuff();
}

inline void CMainWindow::Circle(CDC &dc, int x,int y,int d)
{		
	int xm=x-(d/2);
	int ym=y-(d/2);
	
	dc.Ellipse(xm,ym,xm+d,ym+d);
}

void CMainWindow::DrawStuff()
{
	if(!CheckNextFrame()) return;
	m_iFrame++;

	int i;
    static int x1=10;
    static int x2=320;
    static int y1=10;
    static int y2=260;

    static bool dir;

	if (dir==true)
		{x1--;x2++;y1--;y2++;}

    else
		{x1++;y1++;y2--;x2--;}

	if(x1>250)dir=true;
	if(x1<10)dir=false;	
	
	memDC.SelectStockObject(BLACK_BRUSH);
	memDC.Rectangle(0,0,windowW,windowH);	

	memDC.SelectObject(&fuchsiaPen);	

    for(i=-100; i<300; i+=10)
    {
    	Circle(memDC,0,0,x1-i);
        Circle(memDC,0,windowH,x1-i);
        Circle(memDC,windowW,0,x1-i);
        Circle(memDC,windowW,windowH,x1-i);
    }
	
	memDC.SelectObject(&bluePen);

	for(i=100; i>-100; i-=10)Circle(memDC,320,240,x1+i);

    for(i=64; i<254; i+=20)
    {
		memDC.SelectObject(&aquaPen);

		memDC.MoveTo(x1+i,y1+105);
    	memDC.LineTo(x1+i,y2+105);

        memDC.MoveTo(x2+i,y1+105);
    	memDC.LineTo(x2+i,y2+105);

		memDC.SelectObject(&redPen);

		memDC.MoveTo(x1+i,y1+105);
    	memDC.LineTo(x2+i,y2+105);

		memDC.SelectObject(&yellowPen);

		memDC.MoveTo(x2+i,y1+105);
        memDC.LineTo(x1+i,y2+105);
    }    

	//copy the memory bitmap to the screen
	CClientDC dc(this);    
    dc.BitBlt(0,0,windowW,windowH,&memDC,0,0,SRCCOPY);	

	//reselect standard GDI objects
	memDC.SelectStockObject(BLACK_PEN);
	memDC.SelectStockObject(WHITE_BRUSH);	
}
